# № 9069 Danov2306 (Уровень: Сложный)
# (А.Богданов) Обозначим операцию целочисленного деления с округлением вниз
# как //, а нахождения остатка деления через %. Например, 8//3==2 и 7%3==1.
# Алгоритм вычисления значения функции F(n), где n – целое число,
# задан следующими соотношениями:

# F(n)=n//3+n%3, если n<9
# F(n)=F(n//9)+F(n%9), если n≥9

# Определите количество натуральных чисел n<9 в 9 степени, для которых 
# № F(n) равно 33
from functools import lru_cache
@lru_cache(None)
def f(n):
    if n<9:
        return n//3+n%3
    if n>=9:
        return f(n//9)+f(n%9)

count=0
for i in range(300000000,387420489):
    if f(i)==33:
        print(f(i))
        count+=1
print(count)
for i in range(200000000,300000000):
    if f(i)==33:
        print(f(i))
        count+=1
print(count)
for i in range(100000000,200000000):
    if f(i)==33:
        print(f(i))
        count+=1
print(count)# Здесь будет ответ 1121
for i in range(15000000,100000000):
    if f(i)==33:
        print(f(i))
        count+=1
print(count)
# Начало: 11:53
# равильный ответ 11:58

